#!/usr/bin/python
# -*- coding: utf-8 -*-

# Copyright (C) 2014 Rod Engerstad

from pzl_lib import PzlG


class ModelData(object):
    """
    The built-in puzzles
    """
    def __init__(self):
        self.puzzle_count = 0
        self.puzzles = [
            [[5, 4], 'OOJLO'],
            [[5, 4], 'OJJOO'],
            [[5, 4], 'LOOOL'],
            [[5, 4], 'LLJOL'],
            [[5, 4], 'LIIJI'],
            [[5, 4], 'JJJOL'],
            [[5, 4], 'LISIL'],
            [[5, 4], 'IJJIZ'],
            [[5, 4], 'LTTIS'],
            [[5, 4], 'JZTTI'],
            [[5, 4], 'ZTTSL'],
            [[5, 4], 'TTOOL'],
            [[5, 4], 'TTLLJ'],
            [[5, 4], 'STJZT'],
            [[5, 4], 'SIJJS'],
            [[5, 4], 'OOTTJ'],
            [[5, 4], 'LOZOJ'],
            [[5, 4], 'LJTTJ'],
            [[5, 4], 'LIJOO'],
            [[5, 4], 'JSOLO'],
            [[5, 4], 'JISLO'],
            [[5, 4], 'ITTJO'],
            [[5, 4], 'IOZLJ'],
            [[5, 4], 'ZSLLI'],
            [[5, 4], 'ZLJZS'],
            [[5, 4], 'ZJTTL'],
            [[5, 4], 'TLTOL'],
            [[5, 4], 'TJTJO'],
            [[5, 4], 'SOIJJ'],
            [[5, 4], 'SJSTT'],
            [[5, 4], 'SILOL'],
            [[5, 4], 'OLLOS'],
            [[5, 4], 'LZZIJ'],
            [[5, 4], 'LZTZT'],
            [[5, 4], 'LZLOI'],
            [[5, 4], 'LZLJJ'],
            [[5, 4], 'LSZSJ'],
            [[5, 4], 'LISJS'],
            [[5, 4], 'JTSTL'],
            [[5, 4], 'JJOOZ'],
            [[5, 4], 'JJLSL'],
            [[5, 4], 'JIJSZ'],
            [[5, 4], 'JIJOZ'],
            [[5, 4], 'TZIIT'],
            [[5, 4], 'TTZJJ'],
            [[5, 4], 'TTISI'],
            [[5, 4], 'OOJJS'],
            [[5, 4], 'LLOOZ'],
            [[5, 4], 'JJIIS'],
            [[5, 4], 'IZLLI'],
            [[6, 4], 'ZTSTLI'],
            [[6, 4], 'ZJITTS'],
            [[6, 4], 'OSJIIL'],
            [[6, 4], 'OJZLLJ'],
            [[6, 4], 'OJLJLS'],
            [[6, 4], 'OIJLIZ'],
            [[6, 4], 'LJIIOO'],
            [[6, 4], 'TIZJTL'],
            [[6, 4], 'TIOITJ'],
            [[6, 4], 'STLTJI'],
            [[6, 4], 'OOLLSI'],
            [[6, 4], 'LTZTJL'],
            [[6, 4], 'JOOZIJ'],
            [[6, 4], 'ZILOIL'],
            [[6, 4], 'TJOTSO'],
            [[6, 4], 'SJIOJI'],
            [[6, 4], 'LZLZJJ'],
            [[6, 4], 'LSLJZL'],
            [[6, 4], 'LLJLSS'],
            [[6, 4], 'LISOIL'],
            [[6, 4], 'LZZOIJ'],
            [[6, 4], 'JZJTIT'],
            [[6, 4], 'ITSLLT'],
            [[6, 4], 'ZLOOIL'],
            [[6, 4], 'ZIZTLT'],
            [[6, 4], 'TTOJZL'],
            [[6, 4], 'TTJSSS'],
            [[6, 4], 'TSZTSJ'],
            [[6, 4], 'TLJSOT'],
            [[6, 4], 'STITZI'],
            [[6, 4], 'SSJISL'],
            [[6, 4], 'SJSLIZ'],
            [[6, 4], 'SJITOT'],
            [[6, 4], 'SIJSLI'],
            [[6, 4], 'SIITIT'],
            [[6, 4], 'LZIIZJ'],
            [[6, 4], 'LTZOTI'],
            [[6, 4], 'JTITSS'],
            [[6, 4], 'JSTTSJ'],
            [[6, 4], 'JOITZT'],
            [[6, 4], 'IOOSJJ'],
            [[6, 4], 'TSZJTZ'],
            [[6, 4], 'SZJIJS'],
            [[6, 4], 'STLSTI'],
            [[6, 4], 'OSJZLI'],
            [[6, 4], 'OJSJIS'],
            [[6, 4], 'JSITJT'],
            [[6, 4], 'IZLZSL'],
            [[6, 4], 'IZJIJZ'],
            [[6, 4], 'IJZZTT'],
            [[7, 4], 'TJSOITS'],
            [[7, 4], 'SITTJJO'],
            [[7, 4], 'OZTTILZ'],
            [[7, 4], 'LZLITTO'],
            [[7, 4], 'LOLZIIZ'],
            [[7, 4], 'IOJJISS'],
            [[7, 4], 'ZZLZLIO'],
            [[7, 4], 'ZZLSZTT'],
            [[7, 4], 'ZJISZJZ'],
            [[7, 4], 'ZJILSZS'],
            [[7, 4], 'TZITJZZ'],
            [[7, 4], 'TSTJLSS'],
            [[7, 4], 'TOOZJTL'],
            [[7, 4], 'TLZZSTS'],
            [[7, 4], 'SZZJTJT'],
            [[7, 4], 'SZLTTLO'],
            [[7, 4], 'SLTOTJO'],
            [[7, 4], 'SLSOJOZ'],
            [[7, 4], 'SJTTZSZ'],
            [[7, 4], 'SJOLOSI'],
            [[7, 4], 'OZJIZLS'],
            [[7, 4], 'OZIOSLL'],
            [[7, 4], 'OTTSJJZ'],
            [[7, 4], 'OSSZIJL'],
            [[7, 4], 'OOSTTSJ'],
            [[7, 4], 'OLLSISI'],
            [[7, 4], 'LZZOOTT'],
            [[7, 4], 'LZTTSSS'],
            [[7, 4], 'LSISTST'],
            [[7, 4], 'LSISLZS'],
            [[7, 4], 'JZZTZLT'],
            [[7, 4], 'JZZLSOO'],
            [[7, 4], 'JZOJISO'],
            [[7, 4], 'JIZZIOJ'],
            [[7, 4], 'ILILZSZ'],
            [[7, 4], 'STISTIZ'],
            [[7, 4], 'ZOTIZTJ'],
            [[7, 4], 'ZISOSJJ'],
            [[7, 4], 'TTOOZJJ'],
            [[7, 4], 'TOOJJTI'],
            [[7, 4], 'SSOTLIT'],
            [[7, 4], 'OOIZTTI'],
            [[7, 4], 'LOSOTLT'],
            [[7, 4], 'LISLZSO'],
            [[7, 4], 'JOJTSST'],
            [[7, 4], 'JJSZOZI'],
            [[7, 4], 'IOLLTOT'],
            [[7, 4], 'ILZSOLZ'],
            [[7, 4], 'JIZISJZ'],
            [[7, 4], 'IISZLLS'],
            [[8, 4], 'ZTZIZTJI'],
            [[8, 4], 'ZTTSIISZ'],
            [[8, 4], 'ZOZZJILI'],
            [[8, 4], 'ZLZTOZTO'],
            [[8, 4], 'ZLZOIJOZ'],
            [[8, 4], 'ZJLLLZOO'],
            [[8, 4], 'TTJJOSLS'],
            [[8, 4], 'TLTZOLZJ'],
            [[8, 4], 'SOSSLJOI'],
            [[8, 4], 'SILLISSI'],
            [[8, 4], 'SIJZZSIL'],
            [[8, 4], 'OZITZTLZ'],
            [[8, 4], 'OTZLSZOT'],
            [[8, 4], 'OTJSTOSJ'],
            [[8, 4], 'OOSIOZLL'],
            [[8, 4], 'OOLZLOZI'],
            [[8, 4], 'OJSISSTT'],
            [[8, 4], 'LSOOJJJS'],
            [[8, 4], 'LOSOJSTT'],
            [[8, 4], 'JZOJSLLZ'],
            [[8, 4], 'JIOZZIJO'],
            [[8, 4], 'ILOSSIOL'],
            [[8, 4], 'IJSZIZJS'],
            [[8, 4], 'ZZSJTOTI'],
            [[8, 4], 'ZZLSTSTL'],
            [[8, 4], 'ZSJZTSJT'],
            [[8, 4], 'TOSTZLIS'],
            [[8, 4], 'STLOSITI'],
            [[8, 4], 'SOLTTJZS'],
            [[8, 4], 'LZTOSZTJ'],
            [[8, 4], 'LTLOSITS'],
            [[8, 4], 'LSOZIISL'],
            [[8, 4], 'JTIZTIZO'],
            [[8, 4], 'IJJTOZTZ'],
            [[8, 4], 'ZZOZSJLI'],
            [[8, 4], 'ZISLLSII'],
            [[8, 4], 'ZIOSSJJS'],
            [[8, 4], 'TSSITSLL'],
            [[8, 4], 'SZIJIIJZ'],
            [[8, 4], 'STTLSOIS'],
            [[8, 4], 'STOLTSJS'],
            [[8, 4], 'OTIZZJZT'],
            [[8, 4], 'OLZLSOZI'],
            [[8, 4], 'OITTSSOL'],
            [[8, 4], 'LZSTSTSL'],
            [[8, 4], 'LZSOJSSI'],
            [[8, 4], 'LSILZZZO'],
            [[8, 4], 'JZTSZZJT'],
            [[8, 4], 'JZLZTTZO'],
            [[8, 4], 'JTSOZJOT'],
            [[6, 6], 'SSZITTSLL'],
            [[6, 6], 'SISZILTTZ'],
            [[6, 6], 'OITZLSSTS'],
            [[6, 6], 'LZILOTOTZ'],
            [[6, 6], 'TTSZSJJZI'],
            [[6, 6], 'TTOSZIIZI'],
            [[6, 6], 'TOZIOZILT'],
            [[6, 6], 'STIISJZJT'],
            [[6, 6], 'SSTITLSSO'],
            [[6, 6], 'LILSSSTOT'],
            [[6, 6], 'ITSIOZOOT'],
            [[6, 6], 'ILZOSOJIZ'],
            [[6, 6], 'ILZLOZIZZ'],
            [[6, 6], 'IIZTLZLTS'],
            [[6, 6], 'ZZLZOSTST'],
            [[6, 6], 'TZIZIJZJT'],
            [[6, 6], 'OJOLSSOZI'],
            [[6, 6], 'OISOTISTL'],
            [[6, 6], 'ISZSJLSIO'],
            [[6, 6], 'ZSLZJOIZS'],
            [[6, 6], 'ZOZOISJTT'],
            [[6, 6], 'TLJOTOOZZ'],
            [[6, 6], 'TJOLOTSOS'],
            [[6, 6], 'SOSTJSTOO'],
            [[6, 6], 'SOOTTJZIS'],
            [[6, 6], 'SLITOTLSO'],
            [[6, 6], 'OLZZOOILZ'],
            [[6, 6], 'LOTSZSTIO'],
            [[6, 6], 'JZSOOSLSI'],
            [[6, 6], 'JOSSLISIO'],
            [[6, 6], 'SZIOZSLLI'],
            [[6, 6], 'SOLILZSIO'],
            [[6, 6], 'OZSTLSTOJ'],
            [[6, 6], 'OSIJOJZZI'],
            [[6, 6], 'OLZOIZILS'],
            [[6, 6], 'JZOOIISJS'],
            [[6, 6], 'SOZITSZIT'],
            [[6, 6], 'SLIISTSTS'],
            [[6, 6], 'SIJTZSJST'],
            [[6, 6], 'SZOISLOJZ'],
            [[6, 6], 'STIJISSTI'],
            [[6, 6], 'SSZLSIIZL'],
            [[6, 6], 'SSJTOJTZZ'],
            [[6, 6], 'LZTSZSLOT'],
            [[6, 6], 'LOOSTTZOL'],
            [[6, 6], 'JTZOTZOOS'],
            [[6, 6], 'SJSSOLTOT'],
            [[6, 6], 'LZJTOSTSZ'],
            [[6, 6], 'LSZZSOIOL'],
            [[6, 6], 'JOJZSZSIO'],
            [[9, 4], 'ZSJSTTIJS'],
            [[9, 4], 'ISJOOTJTI'],
            [[9, 4], 'OIJISZJIS'],
            [[9, 4], 'JTIZTSJZZ'],
            [[9, 4], 'IOZLZIZIL'],
            [[9, 4], 'TOSJZZILT'],
            [[9, 4], 'JJJOTLZZT'],
            [[9, 4], 'ZIOSLOLOI'],
            [[9, 4], 'SIIZLSOLI'],
            [[9, 4], 'OZLOTZJTJ'],
            [[9, 4], 'OZJTIJZJT'],
            [[9, 4], 'LZTSTZISI'],
            [[9, 4], 'TLTZLJSOL'],
            [[9, 4], 'LSLLOSOZJ'],
            [[9, 4], 'IOZOOJOLZ'],
            [[9, 4], 'TSIISTJZO'],
            [[9, 4], 'TJSSTJSJO'],
            [[9, 4], 'OIZSTLZIT'],
            [[9, 4], 'TTIJZJSZS'],
            [[9, 4], 'ZOLZTJSJT'],
            [[9, 4], 'TOLLSTOJJ'],
            [[9, 4], 'OTOZTIIZJ'],
            [[9, 4], 'ZSLOTTJSJ'],
            [[9, 4], 'SOSTOOTIJ'],
            [[9, 4], 'SLILSTZTO'],
            [[9, 4], 'SJOSIISJS'],
            [[9, 4], 'SIJJOTZTS'],
            [[9, 4], 'OLIZZTOTZ'],
            [[9, 4], 'OISZTILTS'],
            [[9, 4], 'JTLLOZZTS'],
            [[9, 4], 'ZZTSLITOZ'],
            [[9, 4], 'TTJSZJSZS'],
            [[9, 4], 'SLZJOTSOT'],
            [[9, 4], 'ISOZZIJZL'],
            [[9, 4], 'IITZOZZTL'],
            [[9, 4], 'ZOOLZZIOL'],
            [[9, 4], 'SZLTSLSZT'],
            [[9, 4], 'SSJTJLSTO'],
            [[9, 4], 'ILOSSIZJZ'],
            [[9, 4], 'SJZSOILSS'],
            [[9, 4], 'LSOOTTSIL'],
            [[9, 4], 'LSIOZSLSS'],
            [[9, 4], 'ITTSSOZZL'],
            [[9, 4], 'ZSJSJOLZL'],
            [[9, 4], 'TOZOLTZZS'],
            [[9, 4], 'ZZISZTOTJ'],
            [[9, 4], 'TJSSOJZTO'],
            [[9, 4], 'SISIZLLOS'],
            [[9, 4], 'OLTSTOZLZ'],
            [[9, 4], 'LTZZSOSTL'],
            [[8, 5], 'ZTTILSJZII'],
            [[8, 5], 'ZJIZOJJOLS'],
            [[8, 5], 'ZOJOJTJTLS'],
            [[8, 5], 'JSITJSTJZJ'],
            [[8, 5], 'OZTOTJOLLS'],
            [[8, 5], 'LLOLSSJLSJ'],
            [[8, 5], 'ILTZTSIOOJ'],
            [[8, 5], 'LTITOTSITS'],
            [[8, 5], 'LIZOIISJZI'],
            [[8, 5], 'TOTTLISSTZ'],
            [[8, 5], 'SSSOLJJLJL'],
            [[8, 5], 'ZZTJLILZLT'],
            [[8, 5], 'TZJJOOSTOJ'],
            [[8, 5], 'SIZSTZLJJT'],
            [[8, 5], 'TTZSSSJJJI'],
            [[8, 5], 'LSLLZJZSLJ'],
            [[8, 5], 'JTZSZLLTOL'],
            [[8, 5], 'LZJOIJJZSS'],
            [[8, 5], 'TOJZTJZSTT'],
            [[8, 5], 'LTOZTTSTSL'],
            [[8, 5], 'LIOILISSTT'],
            [[8, 5], 'OOIISIZJLZ'],
            [[8, 5], 'JZSSOOTTIL'],
            [[8, 5], 'OSOJTSLTJO'],
            [[8, 5], 'OSSLSZLTTJ'],
            [[8, 5], 'SOIZOTLTOO'],
            [[8, 5], 'TIJIZZITSO'],
            [[8, 5], 'TOZIJLTZSZ'],
            [[8, 5], 'TLZIZOTSJS'],
            [[8, 5], 'OITTLLSZIZ'],
            [[8, 5], 'SOJSLSTLTJ'],
            [[8, 5], 'SSSOLJOJZL'],
            [[8, 5], 'ZTOJTJZZJZ'],
            [[8, 5], 'SOIOOLOZOL'],
            [[8, 5], 'IOJJOZOTTZ'],
            [[8, 5], 'TSJZTIZOIZ'],
            [[8, 5], 'TTSSSLJZLJ'],
            [[8, 5], 'ZTOOTZJJIZ'],
            [[8, 5], 'JSZJSJOZJO'],
            [[8, 5], 'IIZLOILZOS'],
            [[8, 5], 'TSOZTSLLIZ'],
            [[8, 5], 'SJSTSJJTSL'],
            [[8, 5], 'OOSISOSJOL'],
            [[8, 5], 'OILSZJIZZZ'],
            [[8, 5], 'JISISOLSZS'],
            [[8, 5], 'OZILZOSSOJ'],
            [[8, 5], 'JOSISZIJOS'],
            [[8, 5], 'OSZOIJZJIZ'],
            [[8, 5], 'ISLZIZSLZI'],
            [[8, 5], 'LZZSZIOSLS'],
            ]
        self.puzzle_count = len(self.puzzles)

    def get_puzzle(self, puzzle_index):
        puzzle = []
        if puzzle_index >= 0 and puzzle_index < self.puzzle_count:
            PzlG.logger.logger.info("puzzle_number " +
                                    str(puzzle_index))
            puzzle = self.puzzles[puzzle_index]
        return puzzle
